##!/usr/bin/perl
#
# Schpati - Pre-Alpha of AndyChat v3.xx
# MODULE: Protocols
#
# Started on Thursday, 17th of February, 2000 around 11.15pm
#
# 25th of March, 2000
# -  (1.05pm) Added better irc__on_disconnect parsing
# -  (1.46pm) Added irc__on_whoisvworld
# -  (1.48pm) Added irc__on_whoishelp
# -  (2.00pm) Better irc__on_disconnect parsing
# -  (3.45pm) Fixed typo which crashed upon topic change
#
# 24th of March, 2000
# -  (1.10am) Added irc__on_cpizza
# -  (1.44am) Completed irc__on_cpizza
# -  (1.46am) Minor fixes to irc__on_cpizza
# -  ( ---- ) Implemented irc__on_endofnames and irc__on_whoreply for stuffz
# -  (3.17am) The new irc__on_join pizza stuff works :)
# -  (3.35am) Added irc__nick
# -  (3.45am) Added irc__on_nicknameinuse
# -  (4.11am) Added CTCP display for people requesting VERSION
# -  (1.24pm) Added whois idle parsing
# -  (1.32pm) Added irc__on_awaytoggle for unaway/nowaway modes
# -  (1.40pm) Added irc__on_away
# -  (1.41pm) Added irc__away
# -  (1.49pm) irc__on_away returns correct stuffz now
# -  (1.59pm) irc__on_awaytoggle now shows the args in grey
# -  (7.49pm) irc__on_msg now adds to pagess buffer
# -  (8.19pm) And does it properly too!
# - (11.14pm) Added irc__part
# - (11.38pm) Added irc__quit
# - (11.44pm) Added irc__on_disconnect
# - (11.51pm) Parsed the quit reason properly
#
# 23rd of March, 2000
# -  (7.03pm) Added irc__ctcp
# - (10.15pm) irc__on_join now sets $usr{id} to hostmask
# - (11.37pm) irc__on_join triggers a ctcp pizza if me = pizza server
#
# 22nd of March, 2000
# -  (1.26am) Added irc__on_nick
#
# 21st of March, 2000
# - (12.38pm) Changed ACS_BULLET to ACS_DEGREE
# -  ( ---- ) Added irc__on_lusers
# -  ( ---- ) Fixed .o. thing on server messies
# -  (1.08pm) -- MARK --
# -  ( ---- ) Added irc__on_notice
# -  (1.40pm) Added irc__on_cversion
# -  ( ---- ) Fixed irc__on_cversion
# -  (2.06pm) Added irc__on_topic
# -  ( ---- ) Fixed irc__on_topic
# -  ( ---- ) Fixed join/part message colours
# -  (2.18pm) Really fixed irc__on_topic
# -  ( ---- ) Fixed wrong character on self-actions
# -  (3.58pm) Added irc__on_quit
# -  (4.00pm) Added reason to quit/part message
# -  (4.05pm) Kinda got the reasons to work
# -  (4.20pm) Added irc__notice
# - (10.28pm) Started whois stuffz
# - (10.32pm) Added irc__on_whoisuser
# - (10.34pm) Added irc__whois
#
# 20th of March, 2000
# - (11.01pm) Finished more of irc__on_caction from earlier
# - ( ----- ) Added irc__privmsg
# - ( ----- ) Added irc__action and got it working!
# - ( ----- ) Added irc__on_motd
#
# 5th of March, 2000
# - (11.14pm) Changed incoming message format and private message format
# - (earlier) Fixed IRC timeouts, even tho I have further work to do on em.
#
# 17th of February, 2000
# - (11.15pm) Initial Development
# - ( ----- ) Added several IRC onevents

# IRC Bits!

sub irc__on_connect {
  my $self = shift;

#  AddLine("Connected to IRC!", Lang(24));
}

sub irc__on_motd {
  my ($self, $event) = @_;

  @args = $event->args;
  shift @args;
  AddLine("@args", "`@" . chr(183) . "`%" . chr(ACS_DEGREE) . "`@" . chr(183) . " `7");
}

sub irc__on_whoisuser {
  my ($self, $event) = @_;

  $tmpnick = ($event->args)[1];
  $tmphost = ($event->args)[2] . "\@" . ($event->args)[3];
  $tmpname = ($event->args)[5];

  @args = $event->args;

  shift @args;
  shift @args;
  shift @args;
  shift @args;
  shift @args;

  AddLine("`0" . chr(183) . "`%" . chr(ACS_DEGREE) . "`0" . chr(183) . " `%$tmpnick `8(`7$tmphost`8) ()");
  AddLine("`0" . chr(183) . "`%" . chr(ACS_DEGREE) . "`0" . chr(183) . " `%i`7rcname  : $tmpname");
}

sub irc__on_whoisserver {
  my ($self, $event) = @_;

  @args = $event->args;

  shift @args;
  shift @args;

  AddLine("`0" . chr(183) . "`%" . chr(ACS_DEGREE) . "`0" . chr(183) . " `%s`7erver   : @args");
}

sub irc__on_whoisoperator {
  my ($self, $event) = @_;

  @args = $event->args;

  shift @args;
  shift @args;

  AddLine("`0" . chr(183) . "`%" . chr(ACS_DEGREE) . "`0" . chr(183) . " `%o`7perator : @args");
}

sub irc__on_whoischanop {
  my ($self, $event) = @_;

  @args = $event->args;

  shift @args;
  shift @args;

  AddLine("`0" . chr(183) . "`%" . chr(ACS_DEGREE) . "`0" . chr(183) . " `%c`7hanop   : @args");
}

sub irc__on_whoisvworld {
  my ($self, $event) = @_;

  $tmphost = ($event->args)[2];

  $tmphost = substr($tmphost, rindex($tmphost, " ") + 1);

  AddLine("`0" . chr(183) . "`%" . chr(ACS_DEGREE) . "`0" . chr(183) . " `%v`7world   : $tmphost");
}

sub irc__on_whoishelp {
  my ($self, $event) = @_;

  @args = $event->args;

  shift @args;

  AddLine("`0" . chr(183) . "`%" . chr(ACS_DEGREE) . "`0" . chr(183) . " `%i`7nfo     : @args");
}

sub irc__on_whoisidle {
  my ($self, $event) = @_;

  @args = $event->args;

  shift @args;
  shift @args;

  $tmpidle = @args[0];
  $tmpsignon = @args[1];

  AddLine("`0" . chr(183) . "`%" . chr(ACS_DEGREE) . "`0" . chr(183) . " `%i`7dle     : " . readablesecs($tmpidle) . " (signon: " . localtime($tmpsignon) . ")");
}

sub irc__on_whoischannels {
  my ($self, $event) = @_;

  @args = $event->args;

  shift @args;
  shift @args;

  AddLine("`0" . chr(183) . "`%" . chr(ACS_DEGREE) . "`0" . chr(183) . " `%c`7hannels : @args");
}

sub irc__on_endofwhois {
  my ($self, $event) = @_;

  AddLine("`0" . chr(183) . "`%" . chr(ACS_DEGREE) . "`0" . chr(183) . " `%e`7nd of WHOIS");
}

sub irc__whois {
  my ($self, $to) = @_;

  $self->whois($to);
}

sub irc__on_away {
  my ($self, $event) = @_;

  @args = $event->args;

  $tmpnick = @args[1];

  shift @args;
  shift @args;

  AddLine("`0" . chr(183) . "`%" . chr(ACS_DEGREE) . "`0" . chr(183) . " `%a`7way     : $tmpnick - @args");
}

sub irc__away {
  my ($self, $data) = @_;

  $self->away($data);
}

sub irc__on_awaytoggle {
  my ($self, $event) = @_;

  @args = $event->args;

  shift @args;

  AddLine("`@" . chr(183) . "`%" . chr(ACS_DEGREE) . "`@" . chr(183) . " `7@args");
}

sub irc__on_nicknameinuse {
  my ($self, $event) = @_;

  $my[$thiswin]{name} = ($event->args)[0];
  $tmpnick = ($event->args)[1];

  AddLine("`@" . chr(183) . "`%" . chr(ACS_DEGREE) . "`@" . chr(183) . " `%$tmpnick `7is already in use or forbidden");
}

sub irc__on_nick {
  my ($self, $event) = @_;

  $tmpnick = $event->nick;
  $newnick = ($event->args)[0];

#  AddLine("Old Nick: $tmpnick... New Nick: $newnick...");
  RenUser($thiswin, $tmpnick, $newnick);

  AddLine("`@" . chr(183) . "`%" . chr(ACS_DEGREE) . "`@" . chr(183) . " `%$tmpnick `7is now known as `3$newnick");
}

sub irc__nick {
  my ($self, $data) = @_;

  $self->nick($data);
}

sub irc__on_lusers {
  my ($self, $event) = @_;

  @args = $event->args;
  shift @args;

  AddLine("@args", "`!" . chr(183) . "`%" . chr(ACS_DEGREE) . "`!" . chr(183) . " `7");
}

sub irc__on_msg {
  my ($self, $event) = @_;

  $tmpnick = $event->nick;
  $tmphost = $event->userhost;

  @args = $event->args;

  if ($paging)
  {
    if ($pagesswaiting > 1)
    {
      $pagesswaiting--; 
      UpdateGame(6);
    }
    if ($pagesswaiting < 22)
    {
      for ($ap_i = $pagesswaiting; $ap_i <= 22; $ap_i++)
      {
        if ($ap_i > 1)
        {
          $pagess[$ap_i - 1] = $pagess[$ap_i];
        }
      }
    }
    $pagess[21] = $tmpnick . " whispers @args";
    AddLog($pagess[21]);
  }

#  AddLine($event->args, "`\$$tmpnick`7: `%");
  AddLine($event->args, "`8[`#$tmpnick`8(`5$tmphost`8)]`7 ");
}

sub irc__on_notice {
  my ($self, $event) = @_;

  $tmpnick = $event->nick;
  $tmphost = $event->userhost;

#  AddLine($event->args, "`\$$tmpnick`7: `%");
  AddLine($event->args, "`8-`#$tmpnick`8(`5$tmphost`8)-`7 ");
}

sub irc__notice {
  my ($self, $to, $data) = @_;

  $self->notice($to, $data);
}

sub irc__on_public {
  my ($self, $event) = @_;

  $tmpnick = $event->nick;

  AddLine($event->args, "`9<`7$tmpnick`9>`7 ");
}

sub irc__privmsg {
  my ($self, $to, $data) = @_;

  $self->privmsg($to, $data);
}

sub irc__on_caction {
  my ($self, $event) = @_;
  @args = $event->args;

  $tmpnick = $event->nick;
  shift @args;

  AddLine("@args", "`8" . chr(ACS_S1) . " `\$$tmpnick `7");
}

sub irc__action {
  my ($self, $to, $data) = @_;

  $self->ctcp("ACTION", $to, $data);
}

sub irc__ctcp {
  my ($self, $to, $data) = @_;

  if (index($data, " ") > -1)
  {
    $self->ctcp(substr($data, 0, index($data, " ")), $to, substr($data, index($data, " ") + 1));
  }
  else
  {
    $self->ctcp($data, $to);
  }
}

sub irc__on_cunknown {
  my ($self, $event) = @_;

  $tmpnick = $event->nick;
  $tmphost = $event->userhost;
  $tmpto = ($event->to)[0];
  @args = $event->args;

  AddLine("`8>`7>`%> `0$tmpnick `8[`2$tmphost`8] `2requested unknown ctcp @args `7from $tmpto");
}

sub irc__on_cpizza {
  my ($self, $event) = @_;

  $tmpnum = FindUser($thiswin, 1, $event->nick);
  $tmpnick = ($event->to)[0];

  if (substr($tmpnick, 0, 1) ne "#" && substr($tmpnick, 0, 1) ne "&")
  {
    # Shouldn't be here..
    irc__on_cunknown($self, $event);
    return;
  }

  if ($tmpnum)
  {
    if ($pizza[$thiswin]{host})
    {
      if ($pizza[$thiswin]{host} eq $usr[$thiswin][$tmpnum]{id})
      {
        $pizza[$thiswin]{host} = "";
        if ($pizza[$thiswin]{toppings} && $pizza[$thiswin]{toppings} > 0)
        {
          for ($ap_i = 1; $ap_i <= $pizza[$thiswin]{toppings}; $ap_i++)
          {
            $pizzatopping[$thiswin][$ap_i]{name} = "";
            $pizzatopping[$thiswin][$ap_i]{price} = "";
          }
        }
        $pizza[$thiswin]{toppings} = "";
        AddLine(Lang(24) . $usr[$thiswin][$tmpnum]{name} . Lang(86));
        return;
      }
      AddLine("Pizza Server Collision!  But we'll ignore this for now...", Lang(16));
    }
    $pizza[$thiswin]{host} = $usr[$thiswin][$tmpnum]{id};
    if ($pizza[$thiswin]{toppings} && $pizza[$thiswin]{toppings} > 0)
    {
      for ($ap_i = 1; $ap_i <= $pizza[$thiswin]{toppings}; $ap_i++)
      {
        $pizzatopping[$thiswin][$ap_i]{name} = "";
        $pizzatopping[$thiswin][$ap_i]{price} = "";
      }
    }
    $pizza[$thiswin]{toppings} = "";
    AddLine(Lang(24) . $usr[$thiswin][$tmpnum]{name} . Lang(85));
  }
  else
  {
    AddLine("Imaginary user tried to start a Pizza Server..", Lang(16));
  }
}

sub irc__on_cversion {
  my ($self, $event) = @_;

  $tmpnick = $event->nick;
  $tmphost = $event->userhost;
  $tmpto = ($event->to)[0];
  @args = $event->args;

  $self->ctcp_reply($event->nick, "VERSION AndyChat v$Version - Build $Build");

  AddLine("`8>`7>`%> `0$tmpnick `8[`2$tmphost`8] `2requested @args `7from $tmpto");
}

sub irc__on_topic {
  my ($self, $event) = @_;

  @args = $event->args;

  shift @args;
  shift @args;

  $window[$thiswin]->{topic} = Strrrp("@args");
  ReTitle("[" . $window[$thiswin]->{channel} . "] " . $window[$thiswin]->{topic});
  refresh();
}

sub irc__on_whoreply {
  my ($self, $event) = @_;

  $tmpchannel = ($event->args)[1];
  $tmpnick = ($event->args)[5];
  $tmphost = ($event->args)[2] . "\@" . ($event->args)[3];
  @args = $event->args;

  shift @args;
  shift @args;
  shift @args;
  shift @args;
  shift @args;
  shift @args;
  shift @args;
  shift @args;

  $tmpname = "@args";

  $tmpnum = FindUser($thiswin, 1, $tmpnick);
  if ($tmpnum)
  {
    $usr[$thiswin][$tmpnum]{name} = $tmpnick;
    $usr[$thiswin][$tmpnum]{id} = $tmphost;
    $usr[$thiswin][$tmpnum]{fullname} = $tmpname;
  }
}

sub irc__on_endofnames {
  my ($self, $event) = @_;

  $tmpchannel = ($event->args)[1];

  $self->who($tmpchannel);
}

sub irc__on_names {
  my ($self, $event) = @_;

  my (@irconlist, $ircchannel) = ($event->args);

  ($ircchannel, @irconlist) = splice @irconlist, 2;
  @irconlist = split(/ /, $irconlist[0]);
  $irconusers = @irconlist;

  for ($ioni = 0; $ioni < $irconusers; $ioni++)
  {
#    AddUser($thiswin, $ioni + 1, $irconlist[$ioni]);
    if (substr($irconlist[$ioni], 0, 1) eq "+")
    {
      $irconlist[$ioni] = substr($irconlist[$ioni], 1);
      if (not FindUser($thiswin, 1, $irconlist[$ioni]))
      {
        AddUser($thiswin, $irconlist[$ioni]);
      }
      $usr[$thiswin]->[FindUser($thiswin, 1, $irconlist[$ioni])]->{voice} = 1;
      RedrawNicks;
    }
    elsif (substr($irconlist[$ioni], 0, 1) eq "@")
    {
      $irconlist[$ioni] = substr($irconlist[$ioni], 1);
      if (not FindUser($thiswin, 1, $irconlist[$ioni]))
      {
        AddUser($thiswin, $irconlist[$ioni]);
      }
      $usr[$thiswin]->[FindUser($thiswin, 1, $irconlist[$ioni])]->{op} = 1;
      RedrawNicks;
    }
    else
    {
      if (not FindUser($thiswin, 1, $irconlist[$ioni]))
      {
        AddUser($thiswin, $irconlist[$ioni]);
      }
    }
  }
}

sub irc__on_join {
  my ($self, $event) = @_;

  $tmpnick = $event->nick;
  $tmphost = $event->userhost;
  $tmpchannel = ($event->to)[0];

  if (not FindUser($thiswin, 1, $tmpnick))
  {
    AddUser($thiswin, $tmpnick);
  }
  $tmpnum = FindUser($thiswin, 1, $tmpnick);
  $usr[$thiswin][$tmpnum]{id} = $tmphost;

  if ($tmpnick eq $my[$thiswin]{name})
  {
    $my[$thiswin]{id} = $tmphost;
  }

  if ($pizza[$thiswin]{host} && $pizza[$thiswin]{host} eq $my[$thiswin]{id})
  {
    $tmppizzas = "";
    if ($pizza[$thiswin]{toppings} && $pizza[$thiswin]{toppings} > 0)
    {
      for ($ap_i = 1; $ap_i <= $pizza[$thiswin]{toppings}; $ap_i++)
      {
        $tmppizzas = $tmppizzas . $pizzatopping[$thiswin][$ap_i]{price} . " " . $pizzatopping[$thiswin][$ap_i]{name};
        if ($ap_i < $pizza[$thiswin]{toppings})
        {
          $tmppizzas = $tmppizzas . "|";
        }
      }
      $tmppizzas = " " . $tmppizzas;
    }
    irc__ctcp($window[$thiswin]{control}, $tmpnick, "PIZZA" . $tmppizzas);
  }

  AddLine("`@" . chr(183) . "`%" . chr(ACS_DEGREE) . "`@" . chr(183) . " `!$tmpnick `8[`3$tmphost`8] `7has joined $tmpchannel");
#  AddLine("*** $tmpnick ($tmphost) has joined channel $tmpchannel", Lang(24));
}

sub irc__part {
  my ($self, $to, $data) = @_;

  $self->part($to);
}

sub irc__on_part {
  my ($self, $event) = @_;

  $tmpnick = $event->nick;
  $tmphost = $event->userhost;
  $tmpchannel = ($event->to)[0];

  @args = $event->args;

  shift @args;
#  shift @args;

  DelUser($thiswin, $tmpnick);

  if ($tmphost eq $my[$thiswin]{id})
  {
    DelUser($thiswin);
    @$usr[$thiswin] = ();
    @$pizza[$thiswin] = ();
    @$pizzatopping[$thiswin] = ();
    $window[$thiswin]{channel} = "";
    RedrawNicks;
    ReTitle("");
  }

  AddLine("`@" . chr(183) . "`%" . chr(ACS_DEGREE) . "`@" . chr(183) . " `7$tmpnick `8[`7$tmphost`8] `7has left $tmpchannel `8[`7@args`8]");
#  AddLine("*** $tmpnick ($tmphost) has left channel $tmpchannel", Lang(24));
}

sub irc__quit {
  my ($self, $data) = @_;

  $self->quit($data);
}

sub irc__on_disconnect {
  my ($self, $event) = @_;

  $tmpnick = ($event->args)[0];

  if (index($tmpnick, ":") > -1)
  {
    $tmpnick = substr($tmpnick, index($tmpnick, ":") + 1);
    $tmpnick = substr($tmpnick, index($tmpnick, ":") + 2);
  }

  if (index($tmpnick, "[") > -1)
  {
    $tmpreason = substr($tmpnick, index($tmpnick, "(") + 1, -1);
    $tmpnick = substr($tmpnick, 0, index($tmpnick, "["));
  }
  else
  {
    if (index($tmpnick, "(") > -1)
    {
      $tmpreason = substr($tmpnick, index($tmpnick, "(") + 1, -1);
      $tmpnick = substr($tmpnick, 0, index($tmpnick, "(") - 1);
    }
    else
    {
      $tmpreason = $tmpnick;
      $tmpnick = $my[$thiswin]{name};
    }
  }

  DelUser($thiswin);
  @$usr[$thiswin] = ();
  @$pizza[$thiswin] = ();
  @$pizzatopping[$thiswin] = ();
  @$my[$thiswin] = ();

  RedrawNicks;

  $window[$thiswin]{channel} = "";
  $window[$thiswin]{protocol} = 1;

  $ircconnections--;

  AddLine("`@" . chr(183) . "`%" . chr(ACS_DEGREE) . "`@" . chr(183) . " `7SignOff `%$tmpnick`7: `8(`7$tmpreason`8)");
}

sub irc__on_quit {
  my ($self, $event) = @_;

  $tmpnick = $event->nick;
  $tmphost = $event->host;
  $tmpchannel = ($event->to)[0];

  @args = $event->args;

#  shift @args;
#  shift @args;

  DelUser($thiswin, $tmpnick);

  AddLine("`@" . chr(183) . "`%" . chr(ACS_DEGREE) . "`@" . chr(183) . " `7SignOff `%$tmpnick`7: $tmpchannel `8(`7@args`8)");
}
